import type { SelectProps } from 'antd';
import type { RefSelectProps } from 'antd/lib/select';
import React from 'react';
import type { ProFormFieldItemProps, ProFormFieldRemoteProps } from '../../interface';
export declare type ProFormSelectProps<T = any> = ProFormFieldItemProps<SelectProps<T> & {
    /**
     * 是否在输入框聚焦时触发搜索
     *
     * @default false
     */
    searchOnFocus?: boolean;
    /**
     * 选择完一个之后是否清空搜索项重新搜索
     *
     * @default false
     */
    resetAfterSelect?: boolean;
    /**
     * 当搜索关键词发生变化时是否请求远程数据
     *
     * @default true
     */
    fetchDataOnSearch?: boolean;
    /** 自定义选项渲染 */
    optionItemRender?: (item: T) => React.ReactNode;
}, RefSelectProps> & {
    options?: SelectProps<any>['options'] | string[];
    mode?: SelectProps<any>['mode'] | 'single';
    showSearch?: SelectProps<any>['showSearch'];
    readonly?: boolean;
} & ProFormFieldRemoteProps;
declare const ProFormSearchSelect: <T>(props: ProFormSelectProps<T>) => React.ReactElement;
declare const WrappedProFormSelect: (<T = any>(props: ProFormSelectProps<T>) => React.ReactElement) & {
    SearchSelect: typeof ProFormSearchSelect;
};
export default WrappedProFormSelect;
